<script>

import { getHeader } from '../util/netutil';

const {shell} = require('electron');
const timers = require('timers');
const path = require('path');

export default {

	props:[ 'download'],
	data(){
		this.timers = timers;
		return {
			receivedStr:'',
			interval:null
		};
	},
	created(){

		let reader = this.download.reader;

		reader.on( 'end', ()=>{

			this.download.state = 'done';
			this.receivedStr = this.download.received + 'b / ' + this.fileSize;

			if ( this.interval ) {
				this.timers.clearInterval( this.interval );
				this.interval = null;
			}

		});

		reader.on( 'error',(err)=>{
			console.error(err);
			if ( this.interval ) {
				this.timers.clearInterval( this.interval );
				this.interval = null;
			}

		});

		reader.on(

			'data', chunk=>{
				this.download.received += chunk.length;
			}

		);

		reader.on( 'response', resp=>{

			//logAllProps(resp, false );
			this.download.parseHeaders( resp.headers );

			this.download.state = 'running';

			console.log('GOT RESPONSE');
			// text must be updated on an interval or it changes too rapidly.
			this.interval = this.timers.setInterval( ()=>{

				this.receivedStr = this.download.received + 'b / ' + this.fileSize;

			}, 500 );


		});

		reader.on('info', (info,format)=>{
			console.log('FORMAT RECEIVED');
			//logObj(format);
		});


	},
	computed:{

		fileName() {

			let path = this.download.path;
			let ind = path.lastIndexOf( '\/' );
			if ( ind < 0 ) return path;
			return path.slice( ind+1 );

		},
		fileSize() {
			return this.download.size;
		}

	},

	methods:{

		clearClicked() {
			this.download.cancel();
			this.$emit('clear', this.download );
		},

		openFile() {
			shell.openItem( this.download.path );
		},

		showFile() {
			shell.showItemInFolder( this.download.path );
		},

		trashFile() {
			this.download.cancel();
			shell.moveItemToTrash(this.download.path);
			this.$emit('clear', this.download );
		},

		pause() {

		},
		resume(){

		},
		cancel(){
			this.download.cancel();
		}

	}

}
</script>

<template>

	<div>

		<div class="div-close">
			<button @click="clearClicked">[ X ]</button>
		</div>
		<label class="dl-title" :for="elmId('prof')">{{ download.title ? download.title : fileName }}</label>

		<progress :id="elmId('prog')" max="100" :value="download.progress">{{ receivedStr }}</progress>

		<div class="flex-row">
		<h5 class="progress-text">{{ receivedStr }}</h5>
		<span class="success" v-if="download.isComplete"><h5>Download Complete</h5></span>
		</div>

		<span>
		<span v-if="download.isRunning">
		<input type="button" value="Cancel" @click="cancel">
		</span>
		<span v-else-if="download.isComplete">
			<button @click="openFile">Open</button>

		</span>
			<button @click="showFile">Show</button>
			<button @click="trashFile">Trash</button>
		</span>

	</div>


</template>
